<?php

class mottomag_general_settings_page_class{
	public $generalsettings;
	public $shortgeneralsettings;
	public $options_generalsettings;

	
	/***********************************/
	/* 			INITIAL PAGE		   */
	/***********************************/
	

	function __construct(){
		
		global $mottomag_special_id_for_db;
		global $mottomag_admin_helepr_functions;
		/// initial params
		$this->generalsettings = "General Settings";
		$this->shortgeneralsettings = $mottomag_special_id_for_db."";
		
		
		/// get options from data base
		
		$value_of_std[0] = get_theme_mod($this->shortgeneralsettings."_logo_img", get_template_directory_uri().'/images/logo.png');
		$value_of_std[1] = get_theme_mod($this->shortgeneralsettings."_body_back", '');
		$value_of_std[2] = get_theme_mod($this->shortgeneralsettings."_custom_css_enable", '');
		$value_of_std[3] = get_theme_mod($this->shortgeneralsettings."_custom_css_text", '');
		$value_of_std[4] = get_theme_mod($this->shortgeneralsettings."_favicon_img", '');
		$value_of_std[5] = get_theme_mod($this->shortgeneralsettings."_blog_style", 'on');
		$value_of_std[6] = get_theme_mod($this->shortgeneralsettings."_grab_image", '');
		$value_of_std[13] = get_theme_mod($this->shortgeneralsettings."_our_style", '');
		$value_of_std[14] = get_theme_mod($this->shortgeneralsettings."_menu_search_form", '');
		$value_of_std[15] = get_theme_mod($this->shortgeneralsettings."_post_header", '');
		$value_of_std[16] = get_theme_mod($this->shortgeneralsettings."_favicon_enable", '');
		$value_of_std[17] = get_theme_mod($this->shortgeneralsettings."_date_enable", 'on');
		$value_of_std[18] = get_theme_mod($this->shortgeneralsettings."_footer_text_enable", 'on');
		$value_of_std[19] = get_theme_mod($this->shortgeneralsettings."_footer_text", '<div id="footer_info"><img src="'.get_template_directory_uri().'/images/logo.png" class="footer-logo"><div id="copyright"><span id="footer_date" >© 2014</span><span id="" >WordPress Themes by <a href="'.$mottomag_admin_helepr_functions->web_dor_mainl_url.'wordpress-themes/mottomag.html"  target="_blank" title="Web-Dorado">Web-Dorado</a></span></div><div class="clear"></div></div>');
		
		$this->options_generalsettings = array(
			
			'logo_img' => array(
			
				"name" => __("Logo","mottomag"),
				
				"description" => __("You can apply a custom logo image by clicking on the Upload Image button and uploading your image.","mottomag"),
				
				"var_name" => "logo_img",
				
				"id" => $this->shortgeneralsettings."_logo_img",
				
				"std" => $value_of_std[0]
				
			),
			
			'body_back' => array(
			
				"name" => __("General Settings","mottomag"),
				
				"description" => "",
				
				"var_name" => "body_back",
				
				"id" => $this->shortgeneralsettings."_body_back",
				
				"std" => $value_of_std[1]
				
			),
			'custom_css_enable' => array(
			
				"name" => __("Custom CSS","mottomag"),
				
				"description" => __("Custom CSS will change the visual style of the website. The CSS code provided here can be applied to any page or post.","mottomag"),
				
				"var_name" => "custom_css_enable",
				
				"id" => $this->shortgeneralsettings."_custom_css_enable",
				
				"std" => $value_of_std[2]
			),
			
			'custom_css_text' => array(
			
				"name" => __("Custom CSS","mottomag"),
				
				"description" => __("Provide the custom CSS code below.","mottomag"),
				
				"var_name" => "custom_css_text",
				
				"id" => $this->shortgeneralsettings."_custom_css_text",
				
				"std" => $value_of_std[3]
			),
			
			'favicon_img' => array(
			
				"name" => "",
				
				"description" => __("Click on the Upload Image button to upload the favicon image.","mottomag"),
				
				"var_name" => "favicon_img",
				
				"id" => $this->shortgeneralsettings."_favicon_img",
				
				"std" => $value_of_std[4]
				
			),
			
			'blog_style' => array(
			
				"name" => __("Blog Style post format","mottomag"),
				
				"description" => __("Check the box to have short previews for the homepage/index posts.","mottomag"),
				
				"var_name" => "blog_style",
				
				"id" => $this->shortgeneralsettings."_blog_style",
				
				"std" => $value_of_std[5]
			),
			
			'grab_image' => array(
			
				"name" => __("Grab the first post image","mottomag"),
				
				"description" => __("Enable this option if you want to use the images that are already in your post to create a thumbnail
											without using custom fields. In this case thumbnail images will be generated automatically using the
											first image of the post. Note that the image needs to be hosted on your own server.","mottomag"),
				
				"var_name" => "grab_image",
				
				"id" => $this->shortgeneralsettings."_grab_image",
				
				"std" => $value_of_std[6]
			),
			
			'our_style' => array(
			
				"name" => __("General Settings","mottomag"),
				
				"description" => "",
				
				"var_name" => "our_style",
				
				"id" => $this->shortgeneralsettings."_our_style",
				
				"std" => $value_of_std[13]
				
			),
			
			'menu_search_form' => array(
			
				"name" => __("General Settings","mottomag"),
				
				"description" => "",
				
				"var_name" => "menu_search_form",
				
				"id" => $this->shortgeneralsettings."_menu_search_form",
				
				"std" => $value_of_std[14]
				
			),
			
			'post_header' => array(
			
				"name" => __("General Settings","mottomag"),
				
				"description" => "",
				
				"var_name" => "post_header",
				
				"id" => $this->shortgeneralsettings."_post_header",
				
				"std" => $value_of_std[15]
				
			),
			'favicon_enable' => array(
			
				"name" => __("Show Favicon","mottomag"),
				
				"description" => __("Check the box to display the favicon. ","mottomag"),
				
				"var_name" => "favicon_enable",
				
				"id" => $this->shortgeneralsettings."_favicon_enable",
				
				"std" => $value_of_std[16]
				
			),
			'date_enable' => array(
			
				"name" => __("Display post meta information","mottomag"),
				
				"description" => __("Choose whether to display the post meta information such as date, author and etc.","mottomag"),
				
				"var_name" => "date_enable",
				
				"id" => $this->shortgeneralsettings."_date_enable",
				
				"std" => $value_of_std[17]
				
			),
			
			'footer_text_enable' => array(
			
				"name" => __("Information in the Footer","mottomag"),
				
				"description" => __("Check the box to display custom HTML for the footer.","mottomag"),
				
				"var_name" => "footer_text_enable",
				
				"id" => $this->shortgeneralsettings."_footer_text_enable",
				
				"std" => $value_of_std[18]
				
			),

			'footer_text' => array(
			
				"name" => __("Information in the Footer","mottomag"),
				
				"description" => __("Here you can provide the HTML code to be inserted in the footer of your web site.","mottomag"),
				
				"var_name" => "footer_text",
				
				"id" => $this->shortgeneralsettings."_footer_text",
				
				"std" => $value_of_std[19]
				
			)
		);
		
		
	}

	/***********************************/
	/*	  SAVE AND RESET PARAMETRS	   */
	/***********************************/
	
	public function mottomag_theme_update_and_get_options_general_settings(){	
	
		if ( isset($_GET['page']) && $_GET['page'] ==  "web_dorado_theme" && isset($_GET['controller']) && $_GET['controller'] == "general_page") {
			
			if (isset($_REQUEST['action']) && $_REQUEST['action'] == 'save') {
				
				foreach ($this->options_generalsettings as $value) {
					if(isset($value['var_name']) && isset($_REQUEST[$value['var_name']]))
						set_theme_mod($value['id'], $_REQUEST[$value['var_name']]);
					
				}
				
				header("Location: admin.php?page=web_dorado_theme&controller=general_page&saved=true");
				die;
				
			} 
			else {
				
				if (isset($_REQUEST['action']) && $_REQUEST['action'] == 'reset' ) {
					
					foreach ($this->options_generalsettings as $value) {
						if(isset($value['var_name']))
							remove_theme_mod($value['id']);
					}
					
					header("Location: admin.php?page=web_dorado_theme&controller=general_page&reset=true");
					die;
				
				}
			}			
		}	
	}
	
	/***********************************/
	/*	UPDATE ONE PARAM OUT OF CLASS  */
	/***********************************/
	
	public function update_parametr($param_name,$value){
		set_theme_mod($this->options_generalsettings[$param_name]['id'],$value);
	}
	
	/***********************************/
	/*	  SAVE AND RESET PARAMETRS	   */
	/***********************************/
	
	public function mottomag_general_settings_page_admin_scripts(){	
		
		wp_enqueue_style('general_settings_page_main_style',get_template_directory_uri().'/admin/css/general_settings_page.css');	
		wp_enqueue_script('common');
		wp_enqueue_script('jquery-color');
		wp_print_scripts('editor');
		if (function_exists('add_thickbox')) add_thickbox();
		wp_print_scripts('media-upload');
		wp_admin_css();
		wp_enqueue_script('utils');
	
	}
	
	/***********************************/
	/* 		 BACK END ADMIN HTML       */
	/***********************************/
	
	public function mottomag_theme_admin_general_settings(){
		if (isset($_REQUEST['saved']) && $_REQUEST['saved']  && isset($_REQUEST['controller']) && $_REQUEST['controller']=='general_page') 
		
			echo '<div id="message" class="updated"><p><strong>General setting are saved.</strong></p></div>';
			
		if (isset($_REQUEST['reset']) && $_REQUEST['reset']  && isset($_REQUEST['controller']) && $_REQUEST['controller']=='general_page') 
		
			echo '<div id="message" class="updated"><p><strong>General setting are reset.</strong></p></div>';
			
		global $mottomag_admin_helepr_functions,$mottomag_web_dor;
		?>
		<div id="main_general_page">
       
			<table align="center" width="90%" style="margin-top: 0px;border-bottom: rgb(111, 111, 111) solid 2px;">
			    <tr>   
                     <td style="font-size:14px; font-weight:bold">
					     <a href="<?php echo $mottomag_web_dor.'/wordpress-themes-guide-step-1.html'; ?>" target="_blank" style="color:#126094; text-decoration:none;"><?php echo __("User Manual", "mottomag" ); ?> </a><br /><?php echo __("This section allows you to make changes in overall content of the site.", "mottomag" ); ?> 
                         <a href="<?php echo $mottomag_web_dor.'/wordpress-theme-options/3-3.html'; ?>" target="_blank" style="color:#126094; text-decoration:none;"><?php echo __("More...", "mottomag" ); ?> </a>
					 </td>  
                      <td  align="right" style="font-size:16px;">
                           <a href="<?php echo $mottomag_web_dor.'/wordpress-themes/mottomag.html'; ?>" target="_blank" style="color:red; text-decoration:none;">
                              <img src="<?php echo get_template_directory_uri() ?>/images/header.png" border="0" alt="" width="215">
                           </a>
                        </td>
                </tr>
				<tr>
					<td>
						<h3 style="margin: 0px;font-family:Segoe UI;padding-bottom: 15px;color: rgb(111, 111, 111); font-size:18pt;"><?php echo __("General", "mottomag" ); ?> </h3>
					</td>
				</tr>
			</table>
			<form method="post" action="themes.php?page=web_dorado_theme&controller=general_page">
					
				<table align="center" width="90%" style=" padding-bottom:0px; padding-top:0px;">
					<tr>
						<td>
							<div id="wrap-general"  class="content-div ui-tabs-panel ui-widget-content ui-corner-bottom ui-tabs ui-widget ui-corner-all">
							<?php 
								$mottomag_admin_helepr_functions->checkbox_with_textarea($this->options_generalsettings['custom_css_enable'],$this->options_generalsettings['custom_css_text']); 
								$mottomag_admin_helepr_functions->only_upload($this->options_generalsettings['logo_img']);
								$mottomag_admin_helepr_functions->checkbox_with_upload($this->options_generalsettings['favicon_enable'],$this->options_generalsettings["favicon_img"]); 
								$mottomag_admin_helepr_functions->only_checkbox($this->options_generalsettings['blog_style']); 
								$mottomag_admin_helepr_functions->only_checkbox($this->options_generalsettings['grab_image']); 
								$mottomag_admin_helepr_functions->only_checkbox($this->options_generalsettings['date_enable']); 
								$mottomag_admin_helepr_functions->checkbox_with_textarea($this->options_generalsettings['footer_text_enable'],$this->options_generalsettings['footer_text']); 
							?>
							</div>		
						</td>
					</tr>
				</table>
					<br/>
	

		<p class="submit" style="float: left; margin-left: 63px; margin-right: 8px;">
			<input class="button" name="save" type="submit" value="Save changes"/>
			<input type="hidden" name="action" value="save"/>
		</p>
		</form>
		<form method="post" action="themes.php?page=web_dorado_theme&controller=general_page">
			<p class="submit">
				<input class="button" name="reset" type="submit" value="Reset"/>
				<input type="hidden" name="action" value="reset"/>
			</p>
		</form>
		</div>
		<?php
	}
	
	/***********************************/
	/* 	  FRONT END FAVICON HTML       */
	/***********************************/

	public function  favicon_img(){
		
		if($this->options_generalsettings['favicon_enable']['std']=='on' && $this->options_generalsettings['favicon_img']['std'])
		{ ?><link rel="shortcut icon" href="<?php if(trim($this->options_generalsettings['favicon_img']['std'])) echo $this->options_generalsettings['favicon_img']['std'];?>" type="image/x-icon" /><?php  }	
	
	}	

}
 