<?php 
class mottomag_categ extends WP_Widget
{
    function mottomag_categ(){
		$widget_ops = array('description' => __('Displays Categories Links','mottomag'));
		$control_ops = array('width' => '', 'height' => '');
		parent::WP_Widget(false,$name=__('Categories Links','mottomag'),$widget_ops,$control_ops);
	}

  /* Displays the Widget in the front-end */
    function widget($args, $instance){
		extract($args);
		$title =  esc_html( $instance['title']);
		$categ_id = empty( $instance['categ_id'] ) ? '' : $instance['categ_id'];
		$title_bg_img = empty( $instance['title_bg_img'] ) ? '' : $instance['title_bg_img'];
		
		$categ_id = (array) json_decode(stripslashes($categ_id));
		$title_bg_img = (array) json_decode(stripslashes($title_bg_img));

		echo $before_widget;

		if ( $title )
			echo $before_title . $title . $after_title; ?>
		
        <style>	
		 .cat_widg p {
			margin: 0 0 13px !important;
         }
		 .cat_widg {
            padding-bottom: 10px;
			margin-bottom: 5px;
            border-bottom: 1px solid #ededed;
			float: left;
			width: 100%;
         }			
         .widget_mottomag_categ div:last-child div{
		    border-bottom:none !important;
         } 
         .cat_widg_cont {		 		  
           width: 100%;
		 }
		 .cat_widg_cont h3{
		   font-size: 19px !important;
		   margin-top: 0;
           line-height: 15px;
           margin-bottom: 8px !important;
		 }
		 .cat_widg_cont h3 a{
		   font-size:19px !important;
		 }
		 .widget-title{
		   margin-bottom: 0;
		 }
		 .cat_widg-img{
		    width: 75px;
			height: 70px;
			float: left;
			overflow: hidden;
			margin: 0 10px 10px 0 !important;

		}
        </style>		
		<?php	global $mottomag_general_settings_page;
		foreach ($mottomag_general_settings_page->options_generalsettings as $value) {
			if ( isset($value['var_name']) ) {
				$$value['var_name'] = $value['std'];
			}
		}
		$top_tabs_categorys=array();
		foreach( $title_bg_img as $key => $user_upload_img ) {						
				$user_upload[$key]['image_url']=$user_upload_img;						
		}
		foreach( $categ_id as $key => $user_selected_categorie ) {						
			if(get_category($user_selected_categorie)!=NULL){ 
				$top_tabs_categorys[$key]['category_name']=get_category($user_selected_categorie)->name;				
				$top_tabs_categorys[$key]['cat_id']=$user_selected_categorie;
			}	
		}
		
		 for ( $i=1; $i<=count($top_tabs_categorys); $i++) {
			if ( $top_tabs_categorys[$i]['cat_id']!=0 ) { ?>
				<div class="mottomag_categ" style="background:url(<?php echo $user_upload[$i]['image_url']; ?>);">								
					<h3 class="gallery-header">
					   <a href="<?php echo home_url(); ?>/?cat=<?php echo $top_tabs_categorys[$i]['cat_id']; ?>"><?php echo $top_tabs_categorys[$i]['category_name']; ?></a>
					</h3>																							
			   </div>			
			<?php	}
			}
		   wp_reset_query();       		 		
		echo $after_widget;
				
		}

  /*Saves the settings. */
    function update($new_instance, $old_instance){
		
		$instance = $old_instance;
		$instance['title'] = sanitize_text_field( $new_instance['title'] );
		$instance['categ_id'] = wp_filter_post_kses( addslashes($new_instance['categ_id']));
		$instance['title_bg_img'] = wp_filter_post_kses( addslashes($new_instance['title_bg_img']));

		return $instance;
		
		}

  /*Creates the form for the widget in the back-end. */
    function form($instance){
				//Defaults
		$instance = wp_parse_args( (array) $instance, array( 'title'=>'Categories Posts', 'categ_id'=>'0','title_bg_img'=>'' ) );

		$title = esc_attr( $instance['title'] );
		$categ_id =   $instance['categ_id']; 
		$title_bg_img =   $instance['title_bg_img']; 
		$categ_id = (array) json_decode(stripslashes($categ_id)); 
		$title_bg_img = (array) json_decode(stripslashes($title_bg_img)); 
        $user_selected_cat = array();
		$user_upload = array();
		
		foreach($categ_id as $user_selected_category)
		   $user_selected_cat[]=$user_selected_category;
		foreach($title_bg_img as $user_upload_img)
		   $user_upload[]=$user_upload_img;
		
		global $mottomag_script_count;
		$widget_count=$this->number;
        if($widget_count && $mottomag_script_count){
		?>
		<script>
		jQuery(document).ready(function (jQuery) {
				/* set uploader size in resizing*/
				tb_position = function() {
					var tbWindow = jQuery('#TB_window'),
						width = jQuery(window).width(),
						H = jQuery(window).height(),
						W = ( 850 < width ) ? 850 : width,
						adminbar_height = 0;
			
					if ( jQuery('#wpadminbar').length ) {
						adminbar_height = parseInt(jQuery('#wpadminbar').css('height'), 10 );
					}
			
					if ( tbWindow.size() ) {
						tbWindow.width( W - 50 ).height( H - 45 - adminbar_height );
						jQuery('#TB_iframeContent').width( W - 50 ).height( H - 75 - adminbar_height );
						tbWindow.css({'margin-left': '-' + parseInt( ( ( W - 50 ) / 2 ), 10 ) + 'px'});
						if ( typeof document.body.style.maxWidth !== 'undefined' )
							tbWindow.css({'top': 20 + adminbar_height + 'px', 'margin-top': '0'});
					}
				};
				/*setup the var*/
				jQuery('.upload-button').click(function () {
					window.parent.uploadID = jQuery(this).prev('input');
					/*grab the specific input*/
					formfield = jQuery('.upload').attr('name');
					tb_show('', 'media-upload.php?type=image&amp;TB_iframe=true');
					return false;
				});
				window.send_to_editor = function (html) {
					imgurl = jQuery('img', html).attr('src');
					window.parent.uploadID.val(imgurl);
					/*assign the value to the input*/
					tb_remove();
					if_last_add_refresh_input_link(uploadID);
				};
			}); 
			
			function create_select_link(elementt){				
				var Select_options_sp=jQuery(elementt).parent().find('.select_cat_for_link').html();
				var Title_bg_image=jQuery(elementt).parent().find('.title_bg_image').html();
				jQuery(elementt).parent().find('.link_list').append('<select class="select_cat_for_link" onchange="if_last_add_refresh_input_link(this)" >'+Select_options_sp+'</select>').append('<div style="clear:both"></div>').append('<div class="title_bg_image">'+Title_bg_image+'</div>').append(jQuery('.remov_img_link').eq(1).clone()).append('<div style="clear:both"></div>');
				jQuery('.upload-button').click(function () {
					window.parent.uploadID = jQuery(this).prev('input');
					/*grab the specific input*/
					formfield = jQuery('.upload').attr('name');
					tb_show('', 'media-upload.php?type=image&amp;TB_iframe=true');
					return false;
				});
				if_last_add_refresh_input_link(elementt);	
			} 		
			function if_last_add_refresh_input_link(elementt){
				var main_parent_element='';
				var destination=1;
				var kk=0;
				while(destination){
				kk++;
					main_parent_element=jQuery(elementt).parent();
					if(main_parent_element.hasClass('widget-content') || kk>10)
						destination=0;
					elementt=main_parent_element;
				}

				var selected_categories={}
				var sp_coount_select=1;
				var upload_input={}
				var sp_coount_upload=1;

				main_parent_element.find('.select_cat_for_link').each(function(index, element) {						
					selected_categories[''+sp_coount_select+'']=jQuery(this).val();	
					sp_coount_select++;		 
				});
				main_parent_element.find('.upload').each(function(index, element) {				
					upload_input[''+sp_coount_upload+'']=jQuery(this).val();	
					sp_coount_upload++;		
				});
				main_parent_element.find('.categ_link_id').eq(0).val(JSON.stringify(selected_categories));
				main_parent_element.find('.title_bg_img').eq(0).val(JSON.stringify(upload_input));
			}					
			function sp_remove_select_element_link(element){
			elem_parent=jQuery(element).parent();
				if(jQuery(element).parent().parent().find('.link_list').find('.remov_img_link').length>1){
					jQuery(element).prev().prev().prev().remove();
					jQuery(element).prev().prev().remove();
					jQuery(element).prev().remove();
					jQuery(element).next().remove();
					jQuery(element).remove();
				}	
				if_last_add_refresh_input_link(elem_parent);
			}
			
		</script>
       <?php 
          $mottomag_script_count=0;  
		  
	   } ?>
	    <style>	
		 .select_cat_for_link {
			float:left;
         }
        </style>	
		<p><label for="<?php echo $this->get_field_id('title'); ?>"><?php echo __('Title:','mottomag'); ?></label><input class="widefat" id="<?php echo  $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" /></p>
		<div class="link_list">
		<?php $categorys=get_categories('hide_empty=0');
		if(count($categ_id)>=1){
			for($i=0; $i<count($user_selected_cat); $i++){
			?>			
			<select onchange="if_last_add_refresh_input_link(this)" class="select_cat_for_link" >
				<?php foreach($categorys as $category) {?>
				<option <?php selected($user_selected_cat[$i], $category->cat_ID); ?>  value="<?php echo $category->cat_ID ?>"><?php echo $category->name ?></option>
				<?php } ?>
			</select>
            <div style="clear:both"></div>
		    <div class="title_bg_image">
				<div class="optiondescreption">
					<p><?php echo __('Specify a background for category title.','mottomag'); ?></p>
				</div>
				<div class="optioninput upload_images">
					<input type="text" class="upload upload_images" name="title_bg_img" size="36" value="<?php if(isset($user_upload[$i])) echo $user_upload[$i]; ?>" onchange="if_last_add_refresh_input_link(this)"/>
					<input class="upload-button" type="button" value="Upload Image"/>
				</div>
				<div style="clear:both"></div>
			</div>
			<img onclick="sp_remove_select_element_link(this)"  class="remov_img_link" src="<?php echo get_template_directory_uri().'/images/delete_el_hover.png'; ?>" />
			<div style="clear:both"></div>
			<?php } 
		} else {?>
			<select onchange="if_last_add_refresh_input_link(this)" class="select_cat_for_link" >
				<?php foreach($categorys as $category) {?>
				<option <?php selected($categ_id, $category->cat_ID); ?>  value="<?php echo $category->cat_ID ?>"><?php echo $category->name ?></option>
				<?php } ?>
			</select>
			<div style="clear:both"></div>
			<div class="title_bg_image">
				<div class="optiondescreption">
					<p><?php echo __('Specify a background for category title.','mottomag'); ?></p>
				</div>
				<div class="optioninput upload_images">
					<input type="text" class="upload upload_images" name="title_bg_img" size="<?php echo $params["upload_size"]?>" value="<?php echo $upload["std"] ?>" onchange="if_last_add_refresh_input_link(this)"/>
					<input class="upload-button" type="button" value="Upload Image"/>
				</div>
				<div style="clear:both"></div>
			</div>
			<img onclick="sp_remove_select_element_link(this)"  class="remov_img_link" src="<?php echo get_template_directory_uri().'/images/delete_el_hover.png'; ?>" />	<div style="clear:both"></div>		
		<?php } ?>
		</div>
		<input type="button" value="Add Category" onclick="create_select_link(this)" />
		<input type="hidden" class="categ_link_id" name="<?php echo $this->get_field_name('categ_id'); ?>" value='<?php echo stripslashes($instance['categ_id']); ?>' />
		<input type="hidden" class="title_bg_img" name="<?php echo $this->get_field_name('title_bg_img'); ?>" value='<?php echo stripslashes($instance['title_bg_img']); ?>' />

<?php	

}

}// end mottomag_categ class
add_action('widgets_init', create_function('', 'return register_widget("mottomag_categ");'))
?>